import { GetIDFn, IDModifier } from './entity-resolver';
export type IndexAPI<TID, TEntity> = {
    add(entity: TEntity): void;
    has(entity: TEntity): boolean;
    hasId(id: TID): boolean;
    get(id: TID): TEntity | null;
    getAll(): TEntity[];
    remove(entity: TEntity): void;
    removeById(id: TID): void;
};
export type IndexOptions<TID> = {
    idModifier?: IDModifier<TID>;
};
export declare function sameId<TID>(id: TID): TID;
export default function makeIndex<TEntity, TID>(getId: GetIDFn<TID, TEntity>, source?: TEntity[] | null, options?: IndexOptions<TID>): IndexAPI<TID, TEntity>;
